package cn.com.qmth.examcloud.core.examwork.dao;

import cn.com.qmth.examcloud.api.commons.enums.NoticePublishStatus;
import cn.com.qmth.examcloud.core.examwork.dao.entity.NoticePublishScheduleEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.repository.query.QueryByExampleExecutor;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface NoticePublishScheduleRepo extends JpaRepository<NoticePublishScheduleEntity, Long>,
        QueryByExampleExecutor<NoticePublishScheduleEntity>, JpaSpecificationExecutor<NoticePublishScheduleEntity> {
    List<NoticePublishScheduleEntity> findByRootOrgIdAndPublishStatus(Long rootOrgId, NoticePublishStatus publishStatus);

    NoticePublishScheduleEntity findByRootOrgIdAndNoticeId(Long rootOrgId,Long noticeId);

    List<NoticePublishScheduleEntity> findByPublishStatus(NoticePublishStatus publishStatus);

    @Modifying
    int deleteByRootOrgIdAndNoticeIdIn(Long rootOrgId,List<Long> noticeId);

    @Transactional
    @Modifying
    void deleteByNoticeId(Long noticeId);
}
